Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class OutputStreamWriter

    java.lang.Object
      |
      +--java.io.Writer
            |
            +--java.io.OutputStreamWriter

Direct Known Subclasses:
  FileWriter

public class OutputStreamWriter
extends Writer

An OutputStreamWriter is a bridge from character streams to byte streams: Characters written to it are translated into bytes according to a specified character encoding. The encoding that it uses may be specified by name, or the platform's default encoding may be accepted.

Each invocation of a write() method causes the encoding converter to be invoked on the given character(s). The resulting bytes are accumulated in a buffer before being written to the underlying output stream. The size of this buffer may be specified, but by default it is large enough for most purposes. Note that the characters passed to the write() methods are not buffered.

For top efficiency, consider wrapping an OutputStreamWriter within a BufferedWriter so as to avoid frequent converter invocations. For example:

     Writer out
       = new BufferedWriter(new OutputStreamWriter(System.out));

Since:
  JDK1.1
See Also:
  `BufferedWriter`, `OutputStream`, Character encodings

Fields inherited from class java.io.Writer
`lock`

Constructor Summary
`OutputStreamWriter(OutputStream out)` Create an OutputStreamWriter that uses the default character encoding.
`OutputStreamWriter(OutputStream out, String enc)` Create an OutputStreamWriter that uses the named character encoding.

Method Summary
`void` | `close()` Close the stream.
`void` | `flush()` Flush the stream.
`String` | `getEncoding()` Returns the canonical name of the character encoding being used by this stream.
`void` | `write(char[] cbuf, int off, int len)` Write a portion of an array of characters.
`void` | `write(int c)` Write a single character.
`void` | `write(String str, int off, int len)` Write a portion of a string.

Methods inherited from class java.io.Writer
`write, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### OutputStreamWriter

    public OutputStreamWriter(OutputStream out,
                              String enc)
                       throws UnsupportedEncodingException

  Create an OutputStreamWriter that uses the named character encoding.
  Parameters:
    `out` - An OutputStream
    `enc` - The name of a supported character encoding
  Throws:
    `UnsupportedEncodingException` - If the named encoding is not supported

### OutputStreamWriter

    public OutputStreamWriter(OutputStream out)

  Create an OutputStreamWriter that uses the default character encoding.
  Parameters:
    `out` - An OutputStream

Method Detail

### getEncoding

    public String getEncoding()

  Returns the canonical name of the character encoding being used by this stream. If this `OutputStreamWriter` was created with the `OutputStreamWriter(OutputStream, String)` constructor then the returned encoding name, being canonical, may differ from the encoding name passed to the constructor. May return `null` if the stream has been closed.
  Returns:
    a String representing the encoding name, or possibly `null` if the stream has been closed
  See Also:
    Character encodings

### write

    public void write(int c)
               throws IOException

  Write a single character.
  Overrides:
    `write` in class `Writer`
  Throws:
    `IOException` - If an I/O error occurs

### write

    public void write(char[] cbuf,
                      int off,
                      int len)
               throws IOException

  Write a portion of an array of characters.
  Overrides:
    `write` in class `Writer`
  Parameters:
    `cbuf` - Buffer of characters
    `off` - Offset from which to start writing characters
    `len` - Number of characters to write
  Throws:
    `IOException` - If an I/O error occurs

### write

    public void write(String str,
                      int off,
                      int len)
               throws IOException

  Write a portion of a string.
  Overrides:
    `write` in class `Writer`
  Parameters:
    `str` - A String
    `off` - Offset from which to start writing characters
    `len` - Number of characters to write
  Throws:
    `IOException` - If an I/O error occurs

### flush

    public void flush()
               throws IOException

  Flush the stream.
  Overrides:
    `flush` in class `Writer`
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.
  Overrides:
    `close` in class `Writer`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.